Index: src/Actions/SelectionAction/NotAllAtomsInsideSphereAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsInsideSphereAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAllAtomsInsideSphereAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,29 +11,6 @@
 #include "Actions/Action.hpp"
 
-class Vector;
-
-void SelectionNotAllAtomsInsideSphere();
-
-class SelectionNotAllAtomsInsideSphereAction : public Action {
-  friend void SelectionNotAllAtomsInsideSphere(const Vector &position, const double radius);
-
-public:
-  SelectionNotAllAtomsInsideSphereAction();
-  virtual ~SelectionNotAllAtomsInsideSphereAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotAllAtomsInsideSphereAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTALLATOMSINSIDESPHEREACTION_HPP_ */
Index: src/Actions/SelectionAction/NotAllAtomsOfMoleculeAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsOfMoleculeAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAllAtomsOfMoleculeAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotAllAtomsOfMoleculeAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "atom.hpp"
@@ -34,54 +32,19 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotAllAtomsOfMoleculeAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionNotAllAtomsOfMoleculeState : public ActionState {
-public:
-  SelectionNotAllAtomsOfMoleculeState(std::vector<atom*> _selectedAtoms, molecule *_mol) :
-    selectedAtoms(_selectedAtoms),
-    mol(_mol)
-  {}
-  std::vector<atom*> selectedAtoms;
-  molecule *mol;
-};
-
-const char SelectionNotAllAtomsOfMoleculeAction::NAME[] = "unselect-molecules-atoms";
-
-SelectionNotAllAtomsOfMoleculeAction::SelectionNotAllAtomsOfMoleculeAction() :
-  Action(NAME)
-{}
-
-SelectionNotAllAtomsOfMoleculeAction::~SelectionNotAllAtomsOfMoleculeAction()
-{}
-
-void SelectionNotAllAtomsOfMolecule() {
-  ActionRegistry::getInstance().getActionByName(SelectionNotAllAtomsOfMoleculeAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotAllAtomsOfMoleculeAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionNotAllAtomsOfMoleculeAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryMolecule(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "NotAllAtomsOfMoleculeAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionNotAllAtomsOfMoleculeAction::performCall() {
-  molecule *mol = NULL;
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, mol);
+  // obtain information
+  getParametersfromValueStorage();
 
-  DoLog(1) && (Log() << Verbose(1) << "Unselecting all atoms of molecule " << mol->getName() << "." << endl);
-  World::getInstance().unselectAtomsOfMolecule(mol);
-  return Action::state_ptr(new SelectionNotAllAtomsOfMoleculeState(selectedAtoms, mol));
+  DoLog(1) && (Log() << Verbose(1) << "Unselecting all atoms of molecule " << params.mol->getName() << "." << endl);
+  World::getInstance().unselectAtomsOfMolecule(params.mol);
+  return Action::state_ptr(new SelectionNotAllAtomsOfMoleculeState(selectedAtoms, params));
 }
 
@@ -93,5 +56,5 @@
     World::getInstance().selectAtom(*iter);
 
-  return Action::state_ptr(new SelectionNotAllAtomsOfMoleculeState(state->selectedAtoms, state->mol));
+  return Action::state_ptr(_state);
 }
 
@@ -99,7 +62,7 @@
   SelectionNotAllAtomsOfMoleculeState *state = assert_cast<SelectionNotAllAtomsOfMoleculeState*>(_state.get());
 
-  World::getInstance().unselectAtomsOfMolecule(state->mol);
+  World::getInstance().unselectAtomsOfMolecule(state->params.mol);
 
-  return Action::state_ptr(new SelectionNotAllAtomsOfMoleculeState(state->selectedAtoms, state->mol));
+  return Action::state_ptr(_state);
 }
 
@@ -115,2 +78,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotAllAtomsOfMoleculeAction.def
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsOfMoleculeAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/NotAllAtomsOfMoleculeAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * NotAllAtomsOfMoleculeAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (molecule*)
+#define paramtokens (SelectionNotAllAtomsOfMoleculeAction::NAME)
+#define paramreferences (mol)
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotAllAtomsOfMolecule
+#define TOKEN "unselect-molecules-atoms"
+
Index: src/Actions/SelectionAction/NotAllAtomsOfMoleculeAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsOfMoleculeAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAllAtomsOfMoleculeAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,27 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionNotAllAtomsOfMolecule();
-
-class SelectionNotAllAtomsOfMoleculeAction : public Action {
-  friend void SelectionNotAllAtomsOfMolecule();
-
-public:
-  SelectionNotAllAtomsOfMoleculeAction();
-  virtual ~SelectionNotAllAtomsOfMoleculeAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotAllAtomsOfMoleculeAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTALLATOMSOFMOLECULEACTION_HPP_ */
Index: src/Actions/SelectionAction/NotAllMoleculesAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAllMoleculesAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAllMoleculesAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotAllMoleculesAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/MoleculeDescriptor.hpp"
 #include "atom.hpp"
@@ -33,48 +31,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotAllMoleculesAction.hpp"
 
+// and construct the stuff
+#include "NotAllMoleculesAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionNotAllMoleculesAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionNotAllMoleculesState : public ActionState {
-public:
-  SelectionNotAllMoleculesState(std::vector<molecule*> selectedMolecules) :
-    selectedMolecules(selectedMolecules)
-  {}
-  std::vector<molecule*> selectedMolecules;
-};
-
-const char SelectionNotAllMoleculesAction::NAME[] = "unselect-all-molecules";
-
-SelectionNotAllMoleculesAction::SelectionNotAllMoleculesAction() :
-  Action(NAME)
-{}
-
-SelectionNotAllMoleculesAction::~SelectionNotAllMoleculesAction()
-{}
-
-void SelectionNotAllMolecules() {
-  ActionRegistry::getInstance().getActionByName(SelectionNotAllMoleculesAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotAllMoleculesAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionNotAllMoleculesAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionNotAllMoleculesAction::performCall() {
   std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
   DoLog(1) && (Log() << Verbose(1) << "Unselecting all molecules." << endl);
   World::getInstance().clearMoleculeSelection();
-  return Action::state_ptr(new SelectionNotAllMoleculesState(selectedMolecules));
+  return Action::state_ptr(new SelectionNotAllMoleculesState(selectedMolecules,params));
 }
 
@@ -86,13 +54,13 @@
     World::getInstance().selectMolecule(*iter);
 
-  return Action::state_ptr(new SelectionNotAllMoleculesState(state->selectedMolecules));
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr SelectionNotAllMoleculesAction::performRedo(Action::state_ptr _state){
-  SelectionNotAllMoleculesState *state = assert_cast<SelectionNotAllMoleculesState*>(_state.get());
+  //SelectionNotAllMoleculesState *state = assert_cast<SelectionNotAllMoleculesState*>(_state.get());
 
   World::getInstance().clearMoleculeSelection();
 
-  return Action::state_ptr(new SelectionNotAllMoleculesState(state->selectedMolecules));
+  return Action::state_ptr(_state);
 }
 
@@ -108,2 +76,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotAllMoleculesAction.def
===================================================================
--- src/Actions/SelectionAction/NotAllMoleculesAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/NotAllMoleculesAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,24 @@
+/*
+ * NotAllMoleculesAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotAllMolecules
+#define TOKEN "unselect-all-molecules"
+
Index: src/Actions/SelectionAction/NotAllMoleculesAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotAllMoleculesAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAllMoleculesAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -2,5 +2,5 @@
  * NotAllMoleculesAction.hpp
  *
- *  Created on: May 12, 2010
+ *  Created on: Aug 09, 2010
  *      Author: heber
  */
@@ -11,27 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionNotAllMolecules();
-
-class SelectionNotAllMoleculesAction : public Action {
-  friend void SelectionNotAllMolecules();
-
-public:
-  SelectionNotAllMoleculesAction();
-  virtual ~SelectionNotAllMoleculesAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotAllMoleculesAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTALLMOLECULESSACTION_HPP_ */
Index: src/Actions/SelectionAction/NotAtomByElementAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAtomByElementAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAtomByElementAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotAtomByElementAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomTypeDescriptor.hpp"
 #include "atom.hpp"
@@ -34,55 +32,19 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotAtomByElementAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionNotAtomByElementState : public ActionState {
-public:
-  SelectionNotAtomByElementState(std::vector<atom*> _selectedAtoms, const element *_elemental) :
-    selectedAtoms(_selectedAtoms),
-    elemental(_elemental)
-  {}
-  std::vector<atom*> selectedAtoms;
-  const element *elemental;
-};
-
-const char SelectionNotAtomByElementAction::NAME[] = "unselect-atom-by-element";
-
-SelectionNotAtomByElementAction::SelectionNotAtomByElementAction() :
-  Action(NAME)
-{}
-
-SelectionNotAtomByElementAction::~SelectionNotAtomByElementAction()
-{}
-
-void SelectionNotAtomByElement(const element &_element) {
-  ValueStorage::getInstance().setCurrentValue(SelectionNotAtomByElementAction::NAME, _element);
-  ActionRegistry::getInstance().getActionByName(SelectionNotAtomByElementAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotAtomByElementAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionNotAtomByElementAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryElement(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "NotAtomByElementAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionNotAtomByElementAction::performCall() {
-  const element *elemental;
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, elemental);
+  // obtain information
+  getParametersfromValueStorage();
 
-  DoLog(1) && (Log() << Verbose(1) << "Unselecting atoms of type " << *elemental << endl);
-  World::getInstance().unselectAllAtoms(AtomByType(elemental));
-  return Action::state_ptr(new SelectionNotAtomByElementState(selectedAtoms,elemental));
+  DoLog(1) && (Log() << Verbose(1) << "Unselecting atoms of type " << *params.elemental << endl);
+  World::getInstance().unselectAllAtoms(AtomByType(params.elemental));
+  return Action::state_ptr(new SelectionNotAtomByElementState(selectedAtoms,params));
 }
 
@@ -100,5 +62,5 @@
   SelectionNotAtomByElementState *state = assert_cast<SelectionNotAtomByElementState*>(_state.get());
 
-  World::getInstance().unselectAllAtoms(AtomByType(state->elemental));
+  World::getInstance().unselectAllAtoms(AtomByType(state->params.elemental));
 
   return Action::state_ptr(_state);
@@ -116,2 +78,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotAtomByElementAction.def
===================================================================
--- src/Actions/SelectionAction/NotAtomByElementAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/NotAtomByElementAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * NotAtomByElementAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class element;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (const element*)
+#define paramtokens (SelectionNotAtomByElementAction::NAME)
+#define paramreferences (elemental)
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotAtomByElement
+#define TOKEN "unselect-atom-by-element"
+
Index: src/Actions/SelectionAction/NotAtomByElementAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotAtomByElementAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAtomByElementAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,29 +11,6 @@
 #include "Actions/Action.hpp"
 
-class element;
-
-void SelectionNotAtomByElement(const element &_element);
-
-class SelectionNotAtomByElementAction : public Action {
-  friend void SelectionNotAtomByElement(const element &_element);
-
-public:
-  SelectionNotAtomByElementAction();
-  virtual ~SelectionNotAtomByElementAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotAtomByElementAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTATOMBYELEMENTACTION_HPP_ */
Index: src/Actions/SelectionAction/NotAtomByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAtomByIdAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAtomByIdAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotAtomByIdAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
 #include "Helpers/Log.hpp"
@@ -32,53 +30,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotAtomByIdAction.hpp"
 
+// and construct the stuff
+#include "NotAtomByIdAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionNotAtomByIdAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionNotAtomByIdState : public ActionState {
-public:
-  SelectionNotAtomByIdState(atom* _walker) :
-    walker(_walker)
-  {}
-  atom* walker;
-};
-
-const char SelectionNotAtomByIdAction::NAME[] = "unselect-atom-by-id";
-
-SelectionNotAtomByIdAction::SelectionNotAtomByIdAction() :
-  Action(NAME)
-{}
-
-SelectionNotAtomByIdAction::~SelectionNotAtomByIdAction()
-{}
-
-void SelectionNotAtomById(atom *_atom) {
-  ValueStorage::getInstance().setCurrentValue(SelectionNotAtomByIdAction::NAME, _atom);
-  ActionRegistry::getInstance().getActionByName(SelectionNotAtomByIdAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotAtomByIdAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionNotAtomByIdAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryAtom(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionNotAtomByIdAction::performCall() {
-  atom *Walker = NULL;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, Walker);
-
-  if (World::getInstance().isSelected(Walker)) {
-    DoLog(1) && (Log() << Verbose(1) << "Unselecting atom " << *Walker << endl);
-    World::getInstance().unselectAtom(Walker);
-    return Action::state_ptr(new SelectionNotAtomByIdState(Walker));
+  if (World::getInstance().isSelected(params.Walker)) {
+    DoLog(1) && (Log() << Verbose(1) << "Unselecting atom " << *params.Walker << endl);
+    World::getInstance().unselectAtom(params.Walker);
+    return Action::state_ptr(new SelectionNotAtomByIdState(params));
   } else {
     return Action::success;
@@ -89,8 +52,8 @@
   SelectionNotAtomByIdState *state = assert_cast<SelectionNotAtomByIdState*>(_state.get());
 
-  if (state->walker != NULL)
-    World::getInstance().selectAtom(state->walker);
+  if (state->params.Walker != NULL)
+    World::getInstance().selectAtom(state->params.Walker);
 
-  return Action::state_ptr(new SelectionNotAtomByIdState(state->walker));
+  return Action::state_ptr(_state);
 }
 
@@ -98,8 +61,8 @@
   SelectionNotAtomByIdState *state = assert_cast<SelectionNotAtomByIdState*>(_state.get());
 
-  if (state->walker != NULL)
-    World::getInstance().unselectAtom(state->walker);
+  if (state->params.Walker != NULL)
+    World::getInstance().unselectAtom(state->params.Walker);
 
-  return Action::state_ptr(new SelectionNotAtomByIdState(state->walker));
+  return Action::state_ptr(_state);
 }
 
@@ -115,2 +78,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotAtomByIdAction.def
===================================================================
--- src/Actions/SelectionAction/NotAtomByIdAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/NotAtomByIdAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * NotAtomByIdAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class atom;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (atom*)
+#define paramtokens (SelectionNotAtomByIdAction::NAME)
+#define paramreferences (Walker)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotAtomById
+#define TOKEN "unselect-atom-by-id"
+
Index: src/Actions/SelectionAction/NotAtomByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotAtomByIdAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAtomByIdAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,29 +11,6 @@
 #include "Actions/Action.hpp"
 
-class atom;
-
-void SelectionNotAtomById(atom *_atom);
-
-class SelectionNotAtomByIdAction : public Action {
-  friend void SelectionNotAtomById(atom *_atom);
-
-public:
-  SelectionNotAtomByIdAction();
-  virtual ~SelectionNotAtomByIdAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotAtomByIdAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTATOMBYIDACTION_HPP_ */
Index: src/Actions/SelectionAction/NotMoleculeByFormulaAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByFormulaAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotMoleculeByFormulaAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotMoleculeByFormulaAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/MoleculeFormulaDescriptor.hpp"
 #include "molecule.hpp"
@@ -33,59 +31,23 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotMoleculeByFormulaAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionNotMoleculeByFormulaState : public ActionState {
-public:
-  SelectionNotMoleculeByFormulaState(std::vector<molecule*> selectedMolecules, const std::string &_formula) :
-    selectedMolecules(selectedMolecules),
-    formula(_formula)
-  {}
-  std::vector<molecule*> selectedMolecules;
-  std::string formula;
-};
-
-const char SelectionNotMoleculeByFormulaAction::NAME[] = "unselect-molecule-by-formula";
-
-SelectionNotMoleculeByFormulaAction::SelectionNotMoleculeByFormulaAction() :
-  Action(NAME)
-{}
-
-SelectionNotMoleculeByFormulaAction::~SelectionNotMoleculeByFormulaAction()
-{}
-
-void SelectionNotMoleculeByFormula(const std::string &_formula) {
-  ValueStorage::getInstance().setCurrentValue(SelectionNotMoleculeByFormulaAction::NAME, _formula);
-  ActionRegistry::getInstance().getActionByName(SelectionNotMoleculeByFormulaAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotMoleculeByFormulaAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionNotMoleculeByFormulaAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "NotMoleculeByFormulaAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionNotMoleculeByFormulaAction::performCall() {
-  std::string formula;
   std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, formula);
+  // obtain information
+  getParametersfromValueStorage();
 
-  DoLog(1) && (Log() << Verbose(1) << "Unselecting molecules with chemical formula " << formula << ":" << endl);
-  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(formula));
+  DoLog(1) && (Log() << Verbose(1) << "Unselecting molecules with chemical formula " << params.formula << ":" << endl);
+  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(params.formula));
   for (std::vector<molecule *>::const_iterator iter = matchingMolecules.begin(); iter != matchingMolecules.end(); ++iter) {
     DoLog(1) && (Log() << Verbose(1) << "\t" << (*iter)->getId() << ", " << (*iter)->getName() << "." << endl);
   }
-  World::getInstance().unselectAllMolecules(MoleculeByFormula(formula));
-  return Action::state_ptr(new SelectionNotMoleculeByFormulaState(selectedMolecules,formula));
+  World::getInstance().unselectAllMolecules(MoleculeByFormula(params.formula));
+  return Action::state_ptr(new SelectionNotMoleculeByFormulaState(selectedMolecules,params));
 }
 
@@ -103,5 +65,5 @@
   SelectionNotMoleculeByFormulaState *state = assert_cast<SelectionNotMoleculeByFormulaState*>(_state.get());
 
-  World::getInstance().unselectAllMolecules(MoleculeByFormula(state->formula));
+  World::getInstance().unselectAllMolecules(MoleculeByFormula(state->params.formula));
 
   return Action::state_ptr(_state);
@@ -119,2 +81,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotMoleculeByFormulaAction.def
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByFormulaAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/NotMoleculeByFormulaAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * NotMoleculeByFormulaAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class molecule;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (SelectionNotMoleculeByFormulaAction::NAME)
+#define paramreferences (formula)
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotMoleculeByFormula
+#define TOKEN "unselect-molecule-by-formula"
+
Index: src/Actions/SelectionAction/NotMoleculeByFormulaAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByFormulaAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotMoleculeByFormulaAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,29 +11,6 @@
 #include "Actions/Action.hpp"
 
-class molecule;
-
-void SelectionNotMoleculeByFormula(molecule *_mol);
-
-class SelectionNotMoleculeByFormulaAction : public Action {
-  friend void SelectionNotMoleculeByFormula(const std::string &_formula);
-
-public:
-  SelectionNotMoleculeByFormulaAction();
-  virtual ~SelectionNotMoleculeByFormulaAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotMoleculeByFormulaAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTMOLECULEBYFORMULAACTION_HPP_ */
